config/routes.rb
Rails.application.routes.draw do
  root 'setup#index'

  scope "/admin" do
    get '', to: 'setup#index', as: :setup
    get '/login', to: 'sessions#new'
    post '/login', to: 'sessions#create'
    delete 'logout', to: 'sessions#destroy'
    resources :sites
    resources :roles
    resources :users
    resources :employees
    resources :services
  end

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  # get 'demo', controller: :report, action: :demo
  get 'report/referral/:id', controller: :pdf_reports, action: :refer
  get 'report/hhc/:id', controller: :pdf_reports, action: :hhc
  get 'report/assessments/history/:id', controller: :pdf_reports, action: :assessments_history
  get 'assessment', controller: :pdf_reports, action: :assessment
  # post 'test', controller: :test, action: :refer
  # get 'health', controller: :application, action: :health
  get 'about', controller: :application, action: :about
  get 'test', controller: :test, action: :index, as: :test

  #  vvvvvv reports routes vvvvvv
  get 'providers/filter', controller: :reports, action: :providers_filter
  get 'hospital/filter', controller: :reports, action: :hospital_filter_by_type
  get 'reports', controller: :reports, action: :index
  get 'reports/site/referral_patients', controller: :reports, action: :site_referral_patients
  get 'reports/site/referral_patients/details', controller: :reports, action: :site_referral_patients_details
  get 'reports/admin/referral_patients', controller: :reports, action: :admin_referral_patients
  get 'reports/admin/referral_patients/details', controller: :reports, action: :admin_referral_patients_details
  get 'reports/site/assessment_patients', controller: :reports, action: :site_assessment_patients
  get 'reports/site/assessment_patients/details', controller: :reports, action: :site_assessment_patients_details
  get 'reports/admin/assessment_patients', controller: :reports, action: :admin_assessment_patients
  get 'reports/admin/assessment_patients/details', controller: :reports, action: :admin_assessment_patients_details
  #  ^^^^^^ reports routes ^^^^^^
end

app/controllers/employees_controller.rb
class EmployeesController < ApplicationController
  before_action :set_employee, only: %i[show edit update destroy]

  # GET /employees
  # GET /employees.json
  def index
    p session[:hospcode]
    puts "Current Hospcode: #{session[:hospcode]}"
    @employees = Provider.where(hospital: session[:hospcode])
  end

  # GET /employees/1
  # GET /employees/1.json
  def show
  end

  # GET /employees/new
  def new
    @employee = Provider.new
    @prenames = MPrename.all
    @position_types = ProviderPosition.all
  end

  # GET /employees/1/edit
  def edit
    @prenames = MPrename.all
    @position_types = ProviderPosition.all

    p @employee
  end

  # POST /employees
  # POST /employees.json
  def create
    @employee = Provider.new(employee_params)
    @employee.hospital = current_user.hospcode # Fix

    respond_to do |format|
      if @employee.save
        format.html { redirect_to employees_url, notice: 'Employee was successfully created.' }
        format.json { render :show, status: :created, location: @employee }
      else
        @prename_list = MPrename.all
        @position_types = ProviderPosition.all
        format.html { render :new }
        format.json { render json: @employee.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /employees/1
  # PATCH/PUT /employees/1.json
  def update
    respond_to do |format|
      if @employee.update(employee_params)
        format.html { redirect_to employees_url, notice: 'Employee was successfully updated.' }
        format.json { render :show, status: :ok, location: @employee }
      else
        format.html { render :edit }
        format.json { render json: @employee.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /employees/1
  # DELETE /employees/1.json
  def destroy
    @employee.destroy
    respond_to do |format|
      format.html { redirect_to employees_url, notice: 'Employee was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_employee
    @employee = Provider.find(params[:id])
  end

  # Never trust parameters from the scary internet, only allow the white list through.
  def employee_params
    p current_user.hospcode
    puts "Current hospcode"
    params.fetch(:provider, {}).merge(hospital: current_user.hospcode).permit!
  end
end

app/helpers/employees_helper.rb
module EmployeesHelper
end

app/views/employees/_form.html.erb
<%= form_with(url: (employee.persisted? ? employee_path(employee) : employees_path), model: employee, local: true, html: { class: "ui form" }) do |form| %>
  <% if employee.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(employee.errors.count, "error") %> prohibited this employee from being saved:</h2>

      <ul>
      <% employee.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>
  <div class="required field">
    <%= label_tag(:prename, "Prename") %>
    <% prename_array = @prenames.map { |r| [r.label, r.code] } %>
    <%= form.select(:prename, prename_array, class: "ui dropdown") %>
  </div>
  <div class="required field">
    <%= label_tag(:first_name, "First Name") %>
    <%= form.text_field :first_name %>
  </div>
  <div class="field">
    <%= label_tag(:last_name, "Last Name") %>
    <%= form.text_field :last_name %>
  </div>
  <div class="required field">
    <%= label_tag(:provider_identifier, "ID") %>
    <%= form.text_field :provider_identifier %>
  </div>
  <div class="required field">
    <%= label_tag(:position, "Position") %>
    <%= form.text_field :position %>
  </div>
  <div class="field">
    <%= label_tag(:position_type, "Position Type") %>
    <% position_types_array = @position_types.map { |p| [p.label, p.code] } %>
    <%= form.select(:position_type, position_types_array, class: "ui dropdown") %>
  </div>
  <div class="required field">
    <%= label_tag(:department, "Department") %>
    <%= form.text_field :department %>
  </div>
  <div class="field">
    <%= label_tag(:phone_number_work, "Phone Number Work") %>
    <%= form.text_field :phone_number_work %>
  </div>
  <div class="field">
    <%= label_tag(:phone_number_fax, "Phone Number Fax") %>
    <%= form.text_field :phone_number_fax %>
  </div>
  <div class="field">
    <%= label_tag(:phone_number_mobile, "Phone Number Mobile") %>
    <%= form.text_field :phone_number_mobile %>
  </div>
  <%= form.submit "Submit", class: "ui positive button" %>
  <%= link_to cancel, class: "ui button" do %>
    <i class="chevron left icon"></i> Back
  <% end %>
<% end %>

app/views/employees/edit.html.erb
<%= render 'setup/header' %>

<div class="ui basic container segment">
  <h1>Editing Employee</h1>

  <%= render 'form', employee: @employee, cancel: employees_path %>
</div>

app/views/employees/index.html.erb
<%= render 'setup/header' %>

<div class="ui basic container segment">
  <% if notice %>
    <div class="ui info message">
      <p id="notice"><%= notice %></p>
    </div>
  <% end %>

  <h1 class="header">Employees</h1>
  <%= link_to new_employee_path, class: "ui button" do %>
    <i class="plus icon"></i> New Employee
  <% end %>

  <table class="ui celled table">
    <thead>
      <tr class="center aligned">
        <th>No.</th>
        <th>First Name</th>
        <th>Last Name</th>
        <th>Actions</th>
      </tr>
    </thead>

    <tbody>
      <% @employees.each_with_index do |employee, i| %>
        <tr>
          <td class="center aligned"><%= i + 1 %></td>
          <td><%= employee.first_name %></td>
          <td><%= employee.last_name %></td>
          <td>
            <%= link_to employee_path(employee), class: "ui primary basic button" do %>
              <i class="file icon"></i> Show
            <% end %>
            <%= link_to edit_employee_path(employee), class: "ui secondary basic button" do %>
              <i class="edit icon"></i> Edit
            <% end %>
            <%= link_to employee_path(employee), method: :delete, data: { confirm: 'Are you sure?' }, class: "ui negative basic button" do %>
              <i class="trash icon"></i> Delete
            <% end %>
          </td>
        </tr>
      <% end %>
    </tbody>
  </table>
  <br>
</div>

app/views/employees/new.html.erb
<%= render 'setup/header' %>

<div class="ui basic container segment">
  <h1>New Employee</h1>

  <%= render 'form', employee: @employee, cancel: employees_path %>
</div>

app/views/employees/show.html.erb
<%= render 'setup/header' %>

<div class="ui basic container segment">
  <h1>Employee</h1>
  <div class="ui header">
    Set ID:
    <div class="sub header"><%= @employee.set_id %></div>
  </div>
  <div class="ui header">
    First Name:
    <div class="sub header"><%= @employee.first_name %></div>
  </div>
  <div class="ui header">
    Last Name:
    <div class="sub header"><%= @employee.last_name %></div>
  </div>
  <div class="ui header">
    Position:
    <div class="sub header"><%= @employee.position %></div>
  </div>
  <div class="ui header">
    Department:
    <div class="sub header"><%= @employee.department %></div>
  </div>
  <div class="ui header">
    Created At:
    <div class="sub header"><%= @employee.created_at %></div>
  </div>
  <%= link_to edit_employee_path(@employee), class: "ui button" do %>
    <i class="edit icon"></i> Edit
  <% end %>
  <%= link_to employees_path, class: "ui button" do %>
    <i class="chevron left icon"></i> Back
  <% end %>
</div>